Index: DCWoRMS/branches/coolemall/src/simulator/stats/implementation/DCWormsStatistics.java
===================================================================
--- DCWoRMS/branches/coolemall/src/simulator/stats/implementation/DCWormsStatistics.java	(revision 1199)
+++ DCWoRMS/branches/coolemall/src/simulator/stats/implementation/DCWormsStatistics.java	(revision 1207)
@@ -1102,7 +1387,15 @@
 	
 	
-
-	
-	
+	private double calculateMaxValue(ResourceDynamicStats resDynamicStats ){
+		double maxValue = 0;
+
+		Map<Long, Double> history = resDynamicStats.getHistory();
+		for (Long key : history.keySet()) {
+			if(history.get(key) > maxValue){
+				maxValue = history.get(key) ;
+			}
+		}
+		return maxValue;
+	}
 	
 	
@@ -1221,5 +1514,5 @@
 		TaskStats taskStats = new TaskStats(task, startSimulationTime);
 		String uniqueTaskID = getUniqueTaskId(task);
-		taskStats.setProcessorsName(task_processorsMap.get(uniqueTaskID));
+		taskStats.setProcessors(task_processorsMap.get(uniqueTaskID));
 		return taskStats;
 	}
@@ -1484,16 +1777,27 @@
 
 		public int compare(String o1, String o2)  {
-			Integer o1int;
-			Integer o2int;
+			Integer o1int = 0;
+			Integer o2int = 0;
 			String o1string;
-			String o2string;
-			o1string = o1.substring(0, o1.indexOf("_"));
-			o2string = o2.substring(0, o2.indexOf("_"));
-			o1int = Integer.parseInt(o1.substring(o1.indexOf("_")+1));
-			o2int = Integer.parseInt(o2.substring(o2.indexOf("_")+1));
-			//if(o1string.compareTo(o2string) != 0)
-			//	return o1string.compareTo(o2string);
-			//else
+			String o2string = null;
+
+			if(o1.contains("_")){
+				o1string = o1.substring(0, o1.lastIndexOf("_"));
+				o1int = Integer.parseInt(o1.substring(o1.lastIndexOf("_")+1));
+			} else {
+				o1string = o1;
+			}
+			
+			if(o2.contains("_")){
+				o2string = o2.substring(0, o2.lastIndexOf("_"));
+				o2int = Integer.parseInt(o2.substring(o2.lastIndexOf("_")+1));
+			}else {
+				o2string = o2;
+			}
+
+			if(o1int.compareTo(o2int) != 0)
 				return o1int.compareTo(o2int);
+			else
+				return o1string.compareTo(o2string);
 		}
 	}
@@ -1573,4 +1877,5 @@
 	chartAirFlow,
 	textTemperature,
-	chartTemperature;
+	chartTemperature,
+	textUsefulWorl;
 }
Index: DCWoRMS/branches/coolemall/src/simulator/stats/implementation/ResourceAirFlowStats.java
===================================================================
--- DCWoRMS/branches/coolemall/src/simulator/stats/implementation/ResourceAirFlowStats.java	(revision 496)
+++ DCWoRMS/branches/coolemall/src/simulator/stats/implementation/ResourceAirFlowStats.java	(revision 1207)
@@ -12,4 +12,7 @@
 	public ResourceAirFlowStats (String resourceName, ResourceType resourceType, String usageType) {
 		super(resourceName, resourceType, usageType);
+		if(usageType == null){
+			this.usageType = "airflow_volume";
+		}
 	}
 
Index: DCWoRMS/branches/coolemall/src/simulator/stats/implementation/ResourceUsageStats.java
===================================================================
--- DCWoRMS/branches/coolemall/src/simulator/stats/implementation/ResourceUsageStats.java	(revision 496)
+++ DCWoRMS/branches/coolemall/src/simulator/stats/implementation/ResourceUsageStats.java	(revision 1207)
@@ -10,4 +10,7 @@
 	public ResourceUsageStats(String resourceName, ResourceType resourceType, String usageType) {
 		super(resourceName, resourceType, usageType);
+		if(usageType == null){
+			this.usageType = "cpu_load";
+		}
 	}
 
Index: DCWoRMS/branches/coolemall/src/simulator/stats/implementation/ResourceUsefulWorkStats.java
===================================================================
--- DCWoRMS/branches/coolemall/src/simulator/stats/implementation/ResourceUsefulWorkStats.java	(revision 1207)
+++ DCWoRMS/branches/coolemall/src/simulator/stats/implementation/ResourceUsefulWorkStats.java	(revision 1207)
@@ -0,0 +1,60 @@
+package simulator.stats.implementation;
+
+import schedframe.resources.ResourceType;
+import simulator.stats.implementation.out.StatsSerializer;
+
+public class ResourceUsefulWorkStats implements StatsInterface{
+
+	protected String resourceName;
+	protected String usageType;
+	protected ResourceType resourceType;
+	protected long timestamp;
+	protected double value;
+
+	private String[] headers = { "resourceName", "timestamp", "usefulWork" };
+	
+	public ResourceUsefulWorkStats (String resourceName, ResourceType resourceType, String usageType, double value, long timestamp) {
+		this.resourceName = resourceName;
+		this.resourceType = resourceType;
+		this.usageType = usageType;
+		this.value = value;
+		this.timestamp = timestamp;
+		if(usageType == null){
+			this.usageType = "usefulWork";
+		}
+	}
+	
+	public ResourceUsefulWorkStats (String resourceName, ResourceType resourceType, String usageType,  double value) {
+		this(resourceName, resourceType, usageType, value, 0);
+	}
+
+
+	public double getValue() {
+		return value;
+	}
+
+	public Object serialize(StatsSerializer serializer) {
+		return serializer.visit(this);
+	}
+
+	public String getResourceName() {
+		return this.resourceName;
+	}
+	
+	public ResourceType getResourceType() {
+		return resourceType;
+	}
+	
+	public String getUsageType() {
+		return this.usageType;
+	}	
+
+	public String[] getHeaders() {
+		return headers;
+	}
+
+	public long getTimestamp() {
+		return timestamp;
+	}
+
+}
Index: DCWoRMS/branches/coolemall/src/simulator/stats/implementation/ResourceAvailabilityStats.java
===================================================================
--- DCWoRMS/branches/coolemall/src/simulator/stats/implementation/ResourceAvailabilityStats.java	(revision 1207)
+++ DCWoRMS/branches/coolemall/src/simulator/stats/implementation/ResourceAvailabilityStats.java	(revision 1207)
@@ -0,0 +1,60 @@
+package simulator.stats.implementation;
+
+import schedframe.resources.ResourceType;
+import simulator.stats.implementation.out.StatsSerializer;
+
+public class ResourceAvailabilityStats implements StatsInterface{
+
+	protected String resourceName;
+	protected String usageType;
+	protected ResourceType resourceType;
+	protected long timestamp;
+	protected double value;
+
+	private String[] headers = { "resourceName", "timestamp", "availability" };
+	
+	public ResourceAvailabilityStats (String resourceName, ResourceType resourceType, String usageType, double value, long timestamp) {
+		this.resourceName = resourceName;
+		this.resourceType = resourceType;
+		this.usageType = usageType;
+		this.value = value;
+		this.timestamp = timestamp;
+		if(usageType == null){
+			this.usageType = "availability";
+		}
+	}
+	
+	public ResourceAvailabilityStats (String resourceName, ResourceType resourceType, String usageType,  double value) {
+		this(resourceName, resourceType, usageType, value, 0);
+	}
+
+
+	public double getValue() {
+		return value;
+	}
+
+	public Object serialize(StatsSerializer serializer) {
+		return serializer.visit(this);
+	}
+
+	public String getResourceName() {
+		return this.resourceName;
+	}
+	
+	public ResourceType getResourceType() {
+		return resourceType;
+	}
+	
+	public String getUsageType() {
+		return this.usageType;
+	}	
+
+	public String[] getHeaders() {
+		return headers;
+	}
+
+	public long getTimestamp() {
+		return timestamp;
+	}
+
+}
Index: DCWoRMS/branches/coolemall/src/simulator/stats/implementation/ResourceStats.java
===================================================================
--- DCWoRMS/branches/coolemall/src/simulator/stats/implementation/ResourceStats.java	(revision 477)
+++ DCWoRMS/branches/coolemall/src/simulator/stats/implementation/ResourceStats.java	(revision 1207)
@@ -22,5 +22,5 @@
 
 	public ResourceStats(ComputingResource compResource) {
-		this.resourceName = compResource.getName();
+		this.resourceName = compResource.getFullName();
 		init();
 
Index: DCWoRMS/branches/coolemall/src/simulator/stats/implementation/TaskStats.java
===================================================================
--- DCWoRMS/branches/coolemall/src/simulator/stats/implementation/TaskStats.java	(revision 1199)
+++ DCWoRMS/branches/coolemall/src/simulator/stats/implementation/TaskStats.java	(revision 1207)
@@ -2,9 +2,15 @@
 
 
-import java.util.List;
-
+import java.util.HashSet;
+import java.util.Iterator;
+import java.util.Set;
+
+
+import schedframe.resources.computing.ComputingNode;
+import schedframe.resources.computing.ComputingResource;
+import schedframe.resources.computing.Core;
+import schedframe.resources.computing.Processor;
+import simulator.stats.implementation.out.StatsSerializer;
 import dcworms.schedframe.scheduling.Executable;
-
-import simulator.stats.implementation.out.StatsSerializer;
 
 /**
@@ -14,5 +20,5 @@
  */
 public class TaskStats implements StatsInterface {
-	protected List<String> processorsName;
+	protected Set<ComputingResource> processingElements;
 	protected double reservationStartDate;
 	protected double reservationFinishDate;
@@ -26,5 +32,5 @@
 			"ExecutionTime", "ReadyTime", "StartTime", "FlowTime",
 			"WaitingTime", "GQ_WaitingTime", "Lateness", "Tardiness",
-			"ReservStartDate", "ReservFinishDate", "ProcessorName", "Energy"};
+			"ReservStartDate", "ReservFinishDate", "HostNames", "ProcessorName", "Energy", "AppName",};
 
 	public TaskStats(Executable task, long startSimulationTime) {
@@ -147,6 +153,6 @@
 	}
 
-	public void setProcessorsName(List<String> value) {
-		this.processorsName = value;
+	public void setProcessors(Set<ComputingResource> value) {
+		this.processingElements = value;
 	}
 
@@ -159,8 +165,35 @@
 	}
 
-	public List<String> getProcessorsName() {
-		return processorsName;
-	}
-
+	public Set<String> getProcessingElementsName() {
+		Set<String> processingElementsNames = new HashSet<String>();
+		Iterator<ComputingResource> it = processingElements.iterator();
+		while(it.hasNext()) {
+			ComputingResource compRes = it.next();
+			processingElementsNames.add(compRes.getFullName());
+		}
+		return processingElementsNames;
+	}
+
+	public Set<String> getHostName() {
+		Set<String> hostNames = new HashSet<String>();
+		Iterator<ComputingResource> it = processingElements.iterator();
+		while(it.hasNext()) {
+			ComputingResource compRes = it.next();
+			ComputingNode node = null;
+			if(compRes instanceof Core){
+				Core core =(Core) compRes;
+				node = (ComputingNode)core.getNode();
+			} else if(compRes instanceof Processor){
+				Processor proc = (Processor) compRes;
+				node = (ComputingNode)proc.getNode();
+			} else if(compRes instanceof ComputingNode){
+				node = (ComputingNode)compRes;
+			}
+			if(node != null)
+				hostNames.add(node.getFullName());
+		}
+		return hostNames;
+	}
+	
 	public double getReservationStartDate() {
 		return reservationStartDate;
@@ -170,4 +203,15 @@
 		return reservationFinishDate;
 	}
+	
+	public String getExecName() {
+		String execName = null;
+		if(task.getDescription().getExecution() != null) {
+			if(task.getDescription().getExecution().getStdin()!= null && task.getDescription().getExecution().getStdin().length > 0)
+				execName = task.getDescription().getExecution().getStdin()[0].getName();
+			else if(task.getDescription().getExecution().getExecutable() != null && task.getDescription().getExecution().getExecutable().getApplication() != null)
+				execName = task.getDescription().getExecution().getExecutable().getApplication().getName();
+		}
+		return execName;
+	}
 
 	public String[] getHeaders() {
Index: DCWoRMS/branches/coolemall/src/simulator/stats/implementation/ResourcePowerStats.java
===================================================================
--- DCWoRMS/branches/coolemall/src/simulator/stats/implementation/ResourcePowerStats.java	(revision 496)
+++ DCWoRMS/branches/coolemall/src/simulator/stats/implementation/ResourcePowerStats.java	(revision 1207)
@@ -12,4 +12,7 @@
 	public ResourcePowerStats (String resourceName, ResourceType resourceType, String usageType) {
 		super(resourceName, resourceType, usageType);
+		if(usageType == null){
+			this.usageType = "power";
+		}
 	}
 
Index: DCWoRMS/branches/coolemall/src/simulator/stats/implementation/ResourceTemperatureStats.java
===================================================================
--- DCWoRMS/branches/coolemall/src/simulator/stats/implementation/ResourceTemperatureStats.java	(revision 806)
+++ DCWoRMS/branches/coolemall/src/simulator/stats/implementation/ResourceTemperatureStats.java	(revision 1207)
@@ -12,4 +12,7 @@
 	public ResourceTemperatureStats (String resourceName, ResourceType resourceType, String usageType) {
 		super(resourceName, resourceType, usageType);
+		if(usageType == null){
+			this.usageType = "temperature";
+		}
 	}
 
Index: DCWoRMS/branches/coolemall/src/schedframe/SimulatedEnvironment.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/SimulatedEnvironment.java	(revision 1207)
+++ DCWoRMS/branches/coolemall/src/schedframe/SimulatedEnvironment.java	(revision 1207)
@@ -0,0 +1,165 @@
+package schedframe;
+
+import gridsim.GridSim;
+
+import java.util.ArrayList;
+import java.util.HashSet;
+import java.util.Iterator;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.Set;
+
+import schedframe.exceptions.ResourceException;
+import schedframe.resources.ResourceHistoryChanges;
+import schedframe.resources.computing.ComputingResource;
+import schedframe.scheduling.Scheduler;
+
+public class SimulatedEnvironment {
+
+	protected static Scheduler scheduler;
+	protected static List<ComputingResource> computingResources;
+	protected List<Initializable> toInit;
+	protected Set<String> compResLayers;
+	protected static List<ResourceHistoryChanges> compResHistory = new ArrayList<ResourceHistoryChanges>();
+	
+	public SimulatedEnvironment(Scheduler logicalStructure, List<ComputingResource> compResources){
+		scheduler = logicalStructure;
+		computingResources = compResources;
+	}
+
+	public Scheduler getScheduler() {
+		return scheduler;
+	}
+
+	public List<ComputingResource> getComputingResources() {
+		return computingResources;
+	}
+
+	public static ComputingResource getComputingResourceByName(String resourceName) throws ResourceException {
+		ComputingResource resourceWithName = null;
+		for (int i = 0; i < computingResources.size() && resourceWithName == null; i++) {
+			ComputingResource resource = computingResources.get(i);
+			if (resource.getFullName().equals(resourceName))
+				resourceWithName = resource;
+			else
+				resourceWithName = resource.getDescendantByName(resourceName);
+		}
+		return resourceWithName;
+	}
+
+	private static Scheduler getSchedulerByName(String schedulerName) {
+		Scheduler schedulerWithName = null;
+
+		if (scheduler.getName().compareTo(schedulerName) == 0)
+			schedulerWithName = scheduler;
+		else if (scheduler.getChildren() != null) {
+			LinkedList<Scheduler> toExamine = new LinkedList<Scheduler>();
+			toExamine.push(scheduler);
+
+			while (!toExamine.isEmpty() && schedulerWithName != null) {
+				Scheduler scheduler = toExamine.pop();
+				List<Scheduler> schedulers = scheduler.getChildren();
+
+				int numberOfSched = schedulers.size();
+				for (int i = 0; i < numberOfSched; i++) {
+					Scheduler schedulerChild = schedulers.get(i);
+					if(scheduler.getName().equals(schedulerName)){
+						schedulerWithName = schedulerChild;
+						break;
+					} else
+						toExamine.addLast(schedulerChild);
+				}
+			}
+		}
+		return schedulerWithName;
+	}
+	
+	public static Scheduler getScheduler(String resName){
+		if(GridSim.getEntityId(resName) != -1){
+			return getSchedulerByName(resName);
+		}
+		ComputingResource resourceWithName = null;
+		try {
+			resourceWithName = getComputingResourceByName(resName);
+		} catch (ResourceException e) {
+		}
+		/*for(int i = 0 ; i < computingResources.size() && resourceWithName == null; i++){
+			ComputingResource resource = computingResources.get(i);
+			if(resource.getName().equals(resName))
+				resourceWithName = resource;
+			else
+				try {
+					resourceWithName = resource.getDescendantByName(resName);
+				} catch (ResourceException e) {
+					return null;
+				}
+		}*/
+		if(resourceWithName == null)
+			return null;
+		List<ComputingResource> children = resourceWithName.getChildren();
+		Set<Scheduler> childrenSchedulers = new HashSet<Scheduler>();
+		if(children.isEmpty())
+			return null;
+		for(ComputingResource child: children) {
+			childrenSchedulers.add(child.getScheduler());
+		}	
+
+		Set<Scheduler> tempChildrenSchedulers = new HashSet<Scheduler>(childrenSchedulers);
+		while(childrenSchedulers.size() > 1){
+			childrenSchedulers = new HashSet<Scheduler>();
+			for(Scheduler s: tempChildrenSchedulers){
+				childrenSchedulers.add(s.getParent());
+			}
+			tempChildrenSchedulers = new HashSet<Scheduler>(childrenSchedulers);
+		}
+		Iterator<Scheduler> it = childrenSchedulers.iterator();
+		Scheduler potentialScheduler = it.next();
+		if(potentialScheduler.getCompResources().containsAll(children))
+			return potentialScheduler;
+		return null;
+	}
+	
+	public static ComputingResource getCommonComputingResourceParent(List<ComputingResource> compResources){
+		if(compResources.size() == 0)
+			return null;
+		Set<ComputingResource> candidates = new HashSet<ComputingResource>(compResources);
+		while(candidates.size() > 1){
+			Set<ComputingResource> parents = new HashSet<ComputingResource>();
+			Iterator<ComputingResource> it = candidates.iterator();
+			while(it.hasNext()){
+				ComputingResource compRes = it.next();
+				if(compRes.getParent() != null){
+					parents.add(compRes.getParent());
+				}
+				it.remove();
+			}
+			candidates.addAll(parents);
+		}
+		return candidates.toArray(new ComputingResource[0])[0];
+	}
+
+	public void setInitList(List<Initializable> toI) {
+		toInit = toI;
+	}
+
+	public List<Initializable> getToInit() {
+		return toInit;
+	}
+
+	public Set<String> getComputingResourceLayers() {
+		return compResLayers;
+	}
+
+	public void setCompResLayers(Set<String> compResLayers) {
+		this.compResLayers = compResLayers;
+	}
+
+	public static void traceResource(long timestamp, String resourceName, String operation, String paramter){
+		ResourceHistoryChanges rhc = new ResourceHistoryChanges(timestamp, resourceName, operation, paramter);
+		compResHistory.add(rhc);
+	}
+
+	public static List<ResourceHistoryChanges> getCompResHistory() {
+		return compResHistory;
+	}
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/events/scheduling/SchedulingEventCommand.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/events/scheduling/SchedulingEventCommand.java	(revision 477)
+++ DCWoRMS/branches/coolemall/src/schedframe/events/scheduling/SchedulingEventCommand.java	(revision 1207)
@@ -16,5 +16,5 @@
 	public void execute(EventType evType) {
 		SchedulingEvent ev = new SchedulingEvent(evType);
-		ev.setSource(compResource.getName());
+		ev.setSource(compResource.getFullName());
 		compResource.getEventHandler().handleSchedulingEvent(ev);
 	}
@@ -22,5 +22,5 @@
 	public void execute(Event event) {
 		SchedulingEvent ev = new SchedulingEvent(event.getType());
-		ev.setSource(compResource.getName());
+		ev.setSource(compResource.getFullName());
 		compResource.getEventHandler().handleSchedulingEvent(ev);
 	}
Index: DCWoRMS/branches/coolemall/src/schedframe/events/ResourceEventCommand.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/events/ResourceEventCommand.java	(revision 477)
+++ DCWoRMS/branches/coolemall/src/schedframe/events/ResourceEventCommand.java	(revision 1207)
@@ -1,12 +1,12 @@
 package schedframe.events;
 
-import schedframe.resources.computing.ComputingResource;
+import schedframe.resources.devices.PhysicalResource;
 
 public class ResourceEventCommand implements EventCommand {
 
-	private ComputingResource compResource;
+	private PhysicalResource resource;
 	
-	public ResourceEventCommand(ComputingResource compResource) {
-		this.compResource = compResource;
+	public ResourceEventCommand(PhysicalResource resource) {
+		this.resource = resource;
 	}
 	
@@ -17,5 +17,5 @@
 
 	public void execute(Event event) {
-		compResource.getEventHandler().handleResourceEvent(event);
+		resource.getEventHandler().handleResourceEvent(event);
 	}
 
Index: DCWoRMS/branches/coolemall/src/schedframe/scheduling/tasks/Job.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/scheduling/tasks/Job.java	(revision 1159)
+++ DCWoRMS/branches/coolemall/src/schedframe/scheduling/tasks/Job.java	(revision 1207)
@@ -7,5 +7,4 @@
 import org.qcg.broker.schemas.resreqs.types.TaskStatesName;
 
-import gridsim.dcworms.DCWormsTags;
 
 import java.io.StringWriter;
Index: DCWoRMS/branches/coolemall/src/schedframe/scheduling/tasks/TaskInterface.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/scheduling/tasks/TaskInterface.java	(revision 1190)
+++ DCWoRMS/branches/coolemall/src/schedframe/scheduling/tasks/TaskInterface.java	(revision 1207)
@@ -7,5 +7,4 @@
 
 import schedframe.DescriptionContainer;
-import schedframe.scheduling.tasks.phases.ResourceConsumptionProfile;
 import schedframe.scheduling.tasks.requirements.ResourceParameterName;
 
@@ -111,5 +110,5 @@
 	public long getWorkloadLogWaitTime();
 	
-	public ResourceConsumptionProfile getResourceConsumptionProfile();
+	//public ResourceConsumptionProfile getResourceConsumptionProfile();
 	
 	public String getApplicationName();
Index: DCWoRMS/branches/coolemall/src/schedframe/scheduling/tasks/phases/ResourceConsumption.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/scheduling/tasks/phases/ResourceConsumption.java	(revision 1129)
+++ DCWoRMS/branches/coolemall/src/schedframe/scheduling/tasks/phases/ResourceConsumption.java	(revision 1207)
@@ -9,5 +9,6 @@
 import org.qcg.broker.schemas.resreqs.ComputingResourceParameterType;
 import org.qcg.broker.schemas.resreqs.PhaseBehaviourType;
-import org.qcg.broker.schemas.resreqs.ReferenceType;
+import org.qcg.broker.schemas.resreqs.StringParameterType;
+
 import org.qcg.broker.schemas.resreqs.ResourceConsumptionType;
 
@@ -36,6 +37,6 @@
     	if(resConsumptionType.getReferenceHardware() != null){
         	for (int i = 0; i < resConsumptionType.getReferenceHardware().getReference().length; i++){
-        		ReferenceType rt = resConsumptionType.getReferenceHardware().getReference(i);
-        		referenceHardware.put(rt.getName(), rt.getContent());
+        		StringParameterType spt = resConsumptionType.getReferenceHardware().getReference(i);
+        		referenceHardware.put(spt.getName(), spt.getContent());
         	}
     	}
Index: DCWoRMS/branches/coolemall/src/schedframe/scheduling/tasks/phases/ResourceConsumptionProfile.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/scheduling/tasks/phases/ResourceConsumptionProfile.java	(revision 896)
+++ DCWoRMS/branches/coolemall/src/schedframe/scheduling/tasks/phases/ResourceConsumptionProfile.java	(revision 1207)
@@ -2,10 +2,10 @@
 
 import java.util.LinkedList;
-import java.util.List;
 
 public class ResourceConsumptionProfile {
 	
 	protected LinkedList<ResourceConsumption> resourceConsumptionList;
-	protected int currentPhase;
+	protected long usefulWork;
+	private int currentPhase;
 	
 	public ResourceConsumptionProfile() {
@@ -37,3 +37,11 @@
 		this.currentPhase = currentPhase;
 	}
+
+	public long getUsefulWork() {
+		return usefulWork;
+	}
+
+	public void setUsefulWork(long usefulWork) {
+		this.usefulWork = usefulWork;
+	}
 }
Index: DCWoRMS/branches/coolemall/src/schedframe/scheduling/policy/local/LocalManagementSystem.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/scheduling/policy/local/LocalManagementSystem.java	(revision 1162)
+++ DCWoRMS/branches/coolemall/src/schedframe/scheduling/policy/local/LocalManagementSystem.java	(revision 1207)
@@ -24,5 +24,5 @@
 
 import qcg.shared.constants.BrokerConstants;
-import schedframe.ResourceController;
+import schedframe.SimulatedEnvironment;
 import schedframe.events.scheduling.SchedulingEvent;
 import schedframe.events.scheduling.SchedulingEventType;
@@ -323,5 +323,4 @@
 			ExecTask task = iter.next();
 			Executable exec = (Executable)task;
-			//exec.setCompletionPercentage(exec.getCompletionPercentage() + 100 * timeSpan/exec.getEstimatedDuration());
 			exec.setCompletionPercentage(exec.getCompletionPercentage() + 100 * (timeSpan / exec.getEstimatedDuration()));
 			UsedResourcesList usedResourcesList = exec.getUsedResources();
@@ -338,4 +337,5 @@
 			for (ComputingResource resource : pes) {
 				resource.handleEvent(new EnergyEvent(eventType, obj));
+				//DataCenterWorkloadSimulator.getEventManager().sendToResources(resource.getType(), 0, new EnergyEvent(eventType, obj));
 			}
 			/*try {
@@ -350,5 +350,5 @@
 			ComputingResource resource = null;
 			try {
-				resource = ResourceController.getComputingResourceByName(peUnit.getResourceId());
+				resource = SimulatedEnvironment.getComputingResourceByName(peUnit.getResourceId());
 			} catch (ResourceException e) {
 				return;
@@ -428,6 +428,10 @@
 			if(exec.getResourceConsumptionProfile().getCurrentResourceConsumption() == exec.getResourceConsumptionProfile().getResourceConsumptionList().getLast()){
 				scheduler.sendInternal(phaseDuration, DCWormsTags.TASK_EXECUTION_FINISHED, execTask);
+				PEUnit peUnit = (PEUnit)exec.getUsedResources().getLast().getResourceUnits().get(StandardResourceUnitName.PE);
+				notifyComputingResources(peUnit, EnergyEventType.RESOURCE_UTILIZATION_CHANGED, exec);
 			} else {
 				scheduler.sendInternal(phaseDuration, DCWormsTags.TASK_EXECUTION_CHANGED, execTask);
+				PEUnit peUnit = (PEUnit)exec.getUsedResources().getLast().getResourceUnits().get(StandardResourceUnitName.PE);
+				notifyComputingResources(peUnit, EnergyEventType.RESOURCE_UTILIZATION_CHANGED, exec);
 			}
 		}
@@ -540,5 +544,4 @@
 					job.setStatus((int)BrokerConstants.JOB_STATUS_SUBMITTED);
 			} catch (Exception e) {
-				// TODO Auto-generated catch block
 				e.printStackTrace();
 			}
Index: DCWoRMS/branches/coolemall/src/schedframe/scheduling/SchedulerDescription.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/scheduling/SchedulerDescription.java	(revision 477)
+++ DCWoRMS/branches/coolemall/src/schedframe/scheduling/SchedulerDescription.java	(revision 1207)
@@ -2,4 +2,5 @@
 
 import java.util.ArrayList;
+import java.util.Collection;
 import java.util.HashMap;
 import java.util.Iterator;
@@ -9,14 +10,15 @@
 import schedframe.resources.StandardResourceType;
 import schedframe.resources.computing.description.ExecutingResourceDescription;
+import schedframe.resources.computing.description.ResourceDescription;
 import schedframe.resources.providers.ResourceProvider;
-import schedframe.resources.units.AbstractResourceUnit;
 import schedframe.resources.units.ResourceUnit;
 import schedframe.resources.units.ResourceUnitName;
 import schedframe.scheduling.queue.QueueDescription;
 
-public class SchedulerDescription extends ExecutingResourceDescription{
+public class SchedulerDescription extends ResourceDescription implements ExecutingResourceDescription{
 
 	protected ResourceProvider provider;
 	protected List<QueueDescription> accesQueues;
+	protected Map<ResourceUnitName, List<ResourceUnit>> resUnits;
 
 	public SchedulerDescription(ResourceProvider provider){
@@ -62,3 +64,46 @@
 		return provider;
 	}
+	
+	public void addResourceUnit(ResourceUnit unit) {
+		if (this.resUnits == null)
+			this.resUnits = new HashMap<ResourceUnitName, List<ResourceUnit>>(1);
+		List<ResourceUnit> list = null;
+		if (this.resUnits.containsKey(unit.getName())) {
+			list = this.resUnits.get(unit.getName());
+		} else {
+			list = new ArrayList<ResourceUnit>(1);
+			this.resUnits.put(unit.getName(), list);
+		}
+		list.add(unit);
+	}
+	
+	public ResourceUnit getResourceUnit(ResourceUnitName unitName) throws NoSuchFieldException {
+		return getResourceUnitList(unitName).get(0);
+	}
+
+	public List<ResourceUnit> getResourceUnitList(ResourceUnitName unitName) throws NoSuchFieldException {
+		if (resUnits.containsKey(unitName))
+			return resUnits.get(unitName);
+		else
+			throw new NoSuchFieldException("Resource unit " + unitName + " is not available in resource " + this.id);
+	}
+
+	public Collection<ResourceUnit> getResourceUnit() {
+		if (resUnits == null)
+			return null;
+		List<ResourceUnit> values = new ArrayList<ResourceUnit>();
+		Collection<List<ResourceUnit>> lists = resUnits.values();
+		Iterator<List<ResourceUnit>> itr = lists.iterator();
+
+		while (itr.hasNext()) {
+			List<ResourceUnit> list = itr.next();
+			values.addAll(list);
+		}
+
+		return values;
+	}
+
+	public Map<ResourceUnitName, List<ResourceUnit>> getResourceUnits() {
+		return resUnits;
+	}
 }
Index: DCWoRMS/branches/coolemall/src/schedframe/scheduling/ResourceHistoryItem.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/scheduling/ResourceHistoryItem.java	(revision 477)
+++ DCWoRMS/branches/coolemall/src/schedframe/scheduling/ResourceHistoryItem.java	(revision 1207)
@@ -8,4 +8,5 @@
 import schedframe.resources.units.ResourceUnitName;
 
+//TODO - change name
 public class ResourceHistoryItem {
 
Index: DCWoRMS/branches/coolemall/src/schedframe/scheduling/manager/resources/ClusterResourceManager.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/scheduling/manager/resources/ClusterResourceManager.java	(revision 477)
+++ DCWoRMS/branches/coolemall/src/schedframe/scheduling/manager/resources/ClusterResourceManager.java	(revision 1207)
@@ -23,5 +23,5 @@
 	public List<ComputingNode> getComputingNodes(){
 		try {
-			return (List<ComputingNode>) getResourcesOfType(StandardResourceType.ComputingNode);
+			return (List<ComputingNode>) getResourcesOfType(StandardResourceType.Node);
 		} catch (ResourceException e) {
 			return new ArrayList<ComputingNode>();
@@ -40,5 +40,5 @@
 	@SuppressWarnings("unchecked")
 	public List<ComputingNode> getComputingNodes(Properties properties){
-		properties.setProperty("type", StandardResourceType.ComputingNode.toString());
+		properties.setProperty("type", StandardResourceType.Node.toString());
 		return (List<ComputingNode>) filterResources(properties);
 
